var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../scripts/prettify.js\"></script><script src=\"../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>コールバックを使用するときに、シーンの不必要なダーティ化を防ぐ</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>コールバックを使用するときに、シーンの不必要なダーティ化を防ぐ</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a></a></div>\n\
<p>場合によっては、ファイル &gt; 新規(File &gt; New)、ファイル &gt; 保存(File &gt; Save)、またはファイル &gt; ロード(File &gt; Load)などの後でコールバックを使用すると、反復タスクの自動化や作業環境の設定に役立つことがあります。この適用例には、ノード監視ツールを設定する場合や**、ファイル &gt; 新規(File &gt; New)を選択した後のコールバックで、ファイルから設定をロードする、またはテンプレート環境を作成する場合などがあります。ただし、これらの操作を行うと、シーンが不必要にダーティになって、シーンを保存する必要がなくても、その必要があるとユーザが勘違いすることがあります。</p>\n\
<p>この問題を回避するには、<span class=\'code\'>file -modified “true”|”false”</span> コマンドおよびフラグを使用して、シーンのダーティさを <em>リセット</em> します。</p>\n\
<p>例として、Maya インストール フォルダ内にある <span class=\'code\'>$MAYA_LOCATION/scripts/others/supportRenderers.mel</span> ファイルを参照してください。</p>\n\
<p>新しいシーンをロードするときに、Maya は、現在のレンダラが使用可能かどうかを確認します。使用可能でない場合は、現在のレンダラを推奨レンダラに設定します。この setAttr アクションを行うと、シーンがダーティになります。ファイルが単に開かれていて、他の変更が行われていない場合は、シーンをダーティにする必要はありません。</p>\n\
<p>次のコード スニペットは、以下の処理を行います。</p>\n\
<ul>\n\
<li>現在のレンダラを推奨レンダラに設定する前にファイルが変更されたかどうかを照会します。</li>\n\
<li>現在のレンダラを設定する以外の理由でファイルが変更されなかった場合は、ファイルの -modified を false に設定して、シーンのダーティさをリセットします。</li>\n\
</ul>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">{\n\
    int $wasModified = `file -query -modified`;\n\
    setAttr\n\
        &quot;defaultRenderGlobals.currentRenderer&quot;\n\
        -type &quot;string&quot;\n\
        $preferredRenderer;\n\
    // If the scene wasn&#39;t dirtied prior to setting the current renderer,\n\
    // we want to set the scene as not modified to avoid dirtying the scene.\n\
    if (!$wasModified)\n\
    {\n\
        file -modified false;\n\
    }\n\
}\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";