var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>CMakeLists.txt ファイル</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>CMakeLists.txt ファイル</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"cmakelists.txt-\"></a></div>\n\
<p>CMake ツールは、プラグインおよびアプリケーションのプロジェクトを生成する場合に使用します。</p>\n\
<p>プラグインまたはアプリケーションの <span class=\'code\'>CMakeLists.txt</span> ファイルには、プロジェクトを生成するために必要なライブラリ、ソース ファイル、およびビルド関数の情報が含まれています。このファイルは、ソース コードや、プラグインにパッケージ化されている任意の <span class=\'code\'>mel</span> スクリプトとともに、プラグインまたはアプリケーションのフォルダの最上位に配置されています。</p>\n\
<p>このページでは、<span class=\'code\'>CMakeLists.txt</span> ファイルの各部について説明します。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> devkit のサンプル内にある <span class=\'code\'>CMakeLists.txt</span> ファイルを独自に作成するための開始点として使用することができます。</p>\n\
</blockquote>\n\
<p><span class=\'code\'>CMakeLists.txt</span> ファイルの構造は、次のとおりです。</p>\n\
<ol>\n\
<li><p>最低限必要な CMake のバージョン</p>\n\
<p>cmake_minimum_required(VERSION 2.8)</p></li>\n\
<li><p>プロジェクト名。</p>\n\
<p>set(PROJECT_NAME <projectname>)<p></projectname></li>\n\
</ol>\n\
<p>たとえば、<span class=\'code\'>circleNode</span> <span class=\'code\'>CMakeLists.txt</span> ファイルのプロジェクト名セクションは次のようになります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   set(PROJECT_NAME circleNode)\n\
   \n\
<ol>\n\
<li></li></ol></pre></div><p><span class=\'code\'>pluginEntry.cmake</span> ファイルのパス。この行はすべての <span class=\'code\'>CMakeLists.txt</span> ファイルで同一です。</p>\n\
<p>include($ENV{DEVKIT_LOCATION}/cmake/pluginEntry.cmake)</p>\n\
<li><p>必要なリソース ファイルのリスト。</p></li>\n\
\n\
<p>プロジェクトで複数のリソース ファイルを使用している場合は、各ファイルをスペースで区切ります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   set(RESOURCES_FILES myResource.xpm)\n\
   \n\
</pre></div><ol>\n\
<li>プロジェクトに <span class=\'code\'>mel</span> ファイルも必要な場合は、<span class=\'code\'>MEL_FILES</span> セクションでこれらを指定します。</li>\n\
</ol>\n\
<p>プロジェクトで複数の <span class=\'code\'>mel</span> ファイルを使用している場合は、各ファイルをスペースで区切ります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   set(MEL_FILES\n\
   &lt;melFileName1&gt; &lt;melFileName2&gt; &lt;melFileName3&gt;)\n\
   \n\
</pre></div><p>たとえば、<span class=\'code\'>circleNode</span> サンプルには <span class=\'code\'>mel</span> ファイルが含まれていて、<span class=\'code\'>CMakeLists.txt</span> ファイル内に次の行があります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   set(MEL_FILES\n\
   circleNode.mel)\n\
   \n\
</pre></div><ol>\n\
<li><span class=\'code\'>mel</span>、および必要に応じてリソース ファイルを含むソース ファイルのリスト。</li>\n\
</ol>\n\
<p>プロジェクトで複数のソース ファイルを使用している場合は、各ファイルをスペースで区切ります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   set(SOURCE_FILES\n\
   &lt;sourceFileName1&gt; &lt;sourceFileName2&gt; &lt;sourceFileName3&gt;\n\
   ${MEL_FILES}\n\
   ${RESOURCE_FILES})\n\
   \n\
</pre></div><p>たとえば、<span class=\'code\'>circleNode</span> <span class=\'code\'>SOURCE_FILES</span> 変数は次のように定義されます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   set(SOURCE_FILES\n\
   circleNode.cpp\n\
   ${MEL_FILES}\n\
   )\n\
   \n\
</pre></div><ol>\n\
<li>必要な devkit ライブラリのリスト。</li>\n\
</ol>\n\
<p>プロジェクトで複数のライブラリが必要な場合は、各ライブラリをスペースで区切ります。</p>\n\
<p>必要なライブラリを確認するには、C++ API リファレンスを参照してください。</p>\n\
<p>たとえば、<span class=\'code\'>circleNode</span> には OpenMaya および Foundation ライブラリのみが必要です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   set(LIBRARIES\n\
   OpenMaya Foundation\n\
   )\n\
   \n\
</pre></div><ol>\n\
<li><span class=\'code\'>find_package()</span> を使用して追加される、必要なサードパーティ パッケージのリスト。</li>\n\
</ol>\n\
<p><span class=\'code\'>find_package()</span> は <span class=\'code\'>Find&lt;PackageName&gt;.cmake</span> ファイルを使用して、ビルドにパッケージを追加します。これらのファイルは Linux と MacOS の <span class=\'code\'>$DEVKIT_LOCATION/cmake/modules/</span>、および Windows の <span class=\'code\'>%DEVKIT_LOCATION%\\cmake\\modules</span> に配置されています。パッケージを追加するには、<span class=\'code\'>find_package(PackageName)</span> を呼び出します。たとえば、Alembic パッケージを追加するには、<span class=\'code\'>FindAlembic.cmake</span> が <span class=\'code\'>modules</span> フォルダに存在することを確認してから、<span class=\'code\'>CMakeLists.txt</span> ファイルに以下を書き込みます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   find_packaged(Alembic)\n\
   \n\
</pre></div><p>便宜上、devkit には一般に使用されるパッケージ用のマクロが含まれています。マクロの形式は <span class=\'code\'>find_&lt;packageName&gt;</span> です。マクロを呼び出すには、各パッケージの各マクロを独自の行に配置します。たとえば、<span class=\'code\'>zlib</span> および <span class=\'code\'>alembic</span> パッケージを追加するには、<span class=\'code\'>CMakeLists.txt</span> ファイルに次の 2 つの行を追加します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">   find_zlib()\n\
   find_alembic()\n\
   \n\
</pre></div><p>マクロは、次のパッケージで使用できます。</p>\n\
<ul>\n\
<li>libxml2 (<span class=\'code\'>find_libxml2</span>)</li>\n\
<li>openGL (<span class=\'code\'>find_opengl</span>)</li>\n\
<li>zlib (<span class=\'code\'>find_zlib</span>)</li>\n\
<li>tbb (<span class=\'code\'>find_tbb</span>)</li>\n\
<li>alembic (<span class=\'code\'>find_alembic</span>)</li>\n\
<li>Arnold (<span class=\'code\'>find_arnold</span>)</li>\n\
<li>DirectX (<span class=\'code\'>find_directX</span>)</li>\n\
<li>cg および CgGL (<span class=\'code\'>find_cg</span>)</li>\n\
<li>boost (<span class=\'code\'>find_boost</span>)</li>\n\
<li>D3DX11Effects (<span class=\'code\'>find_D3DX11Effects</span>)<br> このリストにないパッケージがプロジェクトで必要な場合は、このパッケージを検索する cmake スクリプトを作成し、<span class=\'code\'>find_package()</span> コマンドで呼び出す必要があります。ガイドに記載されているように、cmake 検索スクリプトは <span class=\'code\'>modules</span> フォルダ内で使用します。</li>\n\
</ul>\n\
<ol>\n\
<li>最後は、ビルド関数です。</li>\n\
</ol>\n\
<p>プラグインを作成している場合は、<span class=\'code\'>build_plugin()</span> を追加します。スタンドアロン アプリケーションを作成している場合は、<span class=\'code\'>build_application()</span> を追加します。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";