var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>複数ファイル モジュールの配布</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>複数ファイル モジュールの配布</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"-\"></a></div>\n\
<p>ごく簡単な Maya アドオンを除き、すべて複数のファイルがあります。たとえば、フル実装のレンダー ユーティリティ ノードには、少なくとも以下の 3 つのファイルがあります。</p>\n\
<ul>\n\
<li>ノードを収めるプラグイン ファイル</li>\n\
<li>アトリビュート エディタ スクリプト</li>\n\
<li>レンダー ノードの作成(Create Render Node)ダイアログでノードを表すアイコン</li>\n\
</ul>\n\
<p>これらの各ファイルは、ターゲット システム上の異なるディレクトリに配置する必要があります。わずか 3 つのファイルでさえも手動で個別にインストール作業はユーザや現場の管理者にとって負担であり、この負担が対象ファイル数の増加によって大きくなると、それだけ作業ミスの可能性も大きくなります。</p>\n\
<p>複数ファイルの配布を簡単にするために、ファイルを一括して<strong>モジュール</strong>にする機能が提供されています。</p>\n\
<div class=\'section\'><a></a><h2>モジュールについて</h2></div>\n\
<p>モジュールは、モジュール記述ファイルを格納するルート ディレクトリと、次に示すサブディレクトリで構成されています。</p>\n\
<ul>\n\
<li>icons</li>\n\
<li>plug-ins</li>\n\
<li>presets</li>\n\
<li>scripts</li>\n\
</ul>\n\
<p>モジュールの作成時、アイコンは <span class=\'code\'>icons</span> サブフォルダ、C++ と Python プラグインは <span class=\'code\'>plug-ins</span> サブフォルダ、プリセットは <span class=\'code\'>presets</span> サブフォルダ(Maya の <span class=\'code\'>presets</span> フォルダと同じ構造)、MEL と Python スクリプトは <span class=\'code\'>scripts</span> サブフォルダに配置します。</p>\n\
<p>これらのフォルダ構造はいずれも、モジュール記述ファイルの中で次の構文を使用してオーバーライドすることができます: <span class=\'code\'>&lt;folder to override&gt;:&lt;new location for this folder&gt;</span>。詳細については、<a href=\'#!/url=./developer/Distributing-Maya-Plug-ins/Maya-module-paths-folders-and.html\' title=\'\'>モジュール フォルダの構造</a>を参照してください。</p>\n\
<p>モジュールのルート ディレクトリには、4 番目のフィールドに提示されたパスを指定したモジュール説明ファイルのコピーを配置します。配布は、ディレクトリ ツリーのコピーを圧縮形式などでユーザに対して提供するだけで済みます。</p>\n\
<div class=\'section\'><a></a><h2>モジュール記述ファイル</h2></div>\n\
<p>モジュール記述ファイルは、4 つの基本フィールドを空白で区切った1行のテキストを含んでいます。</p>\n\
<ul>\n\
<li>プラス記号(+)。モジュールが Maya に追加されていることを示します。</li>\n\
<li>モジュールの名前(スペース不可)</li>\n\
<li>モジュールのバージョン番号(スペース不可)</li>\n\
<li>モジュールのルート ディレクトリのパス(スペース不可)</li>\n\
</ul>\n\
<p>たとえば、バージョン 1.3 の <span class=\'code\'>myModule</span> が <span class=\'code\'>/opt/MyCompany/myModule</span> にインストールされている場合、モジュール ファイルの内容は次のようになります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">+ myModule 1.3 /opt/MyCompany/myModule\n\
</pre></div><p>たとえば、条件はモジュール名の前にも追加することができます。</p>\n\
<p><span class=\'code\'>+ (Conditions ) “moduleName” “moduleVersion” “moduleLocation”</span></p>\n\
<p>条件は次のいずれかです。</p>\n\
<ul>\n\
<li>MAYAVERSION:</li>\n\
<li>PLATFORM:</li>\n\
<li>LOCALE:</li>\n\
</ul>\n\
<p>詳細については、<a href=\'#!/url=./developer/Distributing-Maya-Plug-ins/Maya-module-paths-folders-and.html\' title=\'\'>モジュールのロードのための条件を指定する</a>を参照してください。</p>\n\
<div class=\'section\'><a></a><h2>モジュールをインストールする</h2></div>\n\
<p>モジュールをインストールする個々のユーザは以下の手順を実行します。</p>\n\
<ol>\n\
<li>必要に応じて、配布ファイルを展開します。</li>\n\
<li>モジュールのディレクトリ ツリー全体を目的の場所に移動またはコピーします。</li>\n\
<li>モジュール説明ファイルの 4 番目のフィールドをモジュールのディレクトリ ツリーに合わせてフル パスに変更します。</li>\n\
<li>修正したモジュール説明ファイルのコピーを MAYA_MODULE_PATH 環境変数のフォルダのいずれかに配置します。</li>\n\
</ol>\n\
<p>複数ユーザ向けのモジュールの共通コピーをインストールする現場の管理者は、以下の手順を実行します。</p>\n\
<ol>\n\
<li>必要に応じて、配布ファイルを展開します。</li>\n\
<li>モジュールのディレクトリ ツリー全体をネットワーク ドライブなどすべてのユーザがアクセスできるディレクトリに移動またはコピーします。</li>\n\
<li>モジュール説明ファイルの 4 番目のフィールドをモジュールのディレクトリ ツリーに合わせてフル パスに変更します。</li>\n\
<li>修正したモジュール説明ファイルのコピーを、すべてのユーザの MAYA_MODULE_PATH 環境変数の共有フォルダに配置します。</li>\n\
</ol>\n\
<p>これには、「<a href=\'#!/url=./developer/Distributing-Maya-Plug-ins/Distributing-individual-files.html\' title=\'\'>個別ファイルの配布</a>」で説明した MAYA_PLUG_IN_PATH 変数に対するものと同じ 3 つのアプローチがあります。</p>\n\
<p>Maya を起動すると、モジュール説明ファイルが読み取られ、モジュールの <span class=\'code\'>icons</span> フォルダが XBMLANGPATH に、<span class=\'code\'>plug-ins</span> フォルダが MAYA_PLUG_IN_PATH、<span class=\'code\'>presets</span> フォルダが MAYA_PRESET_PATH に、<span class=\'code\'>scripts</span> フォルダが MAYA_SCRIPT_PATH and PYTHON_PATH に追加されます。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> MAYA_MODULE_PATH は Maya モジュールファイルの検索パスを定義します。この環境変数がどのディレクトリに設定されているかを確認するには､次のように Maya スクリプト エディタ または Maya コマンド ラインで getenv コマンドを使用します｡</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">getenv MAYA_MODULE_PATH\n\
</pre></div><p>希望のディレクトリにこの環境変数を設定することもできます。これを行うには、<span class=\'code\'>Maya.env</span> ファイルを作成する必要があります。</p>\n\
<p>希望のディレクトリに環境変数を設定することもできます。これを行うには、<span class=\'code\'>Maya.env</span> ファイルを作成する必要があります。<span class=\'code\'>Maya.env</span> の詳細については、「<a href=\'#!/url=./developer/Setting-up-your-build.html\' title=\'\'>ビルド環境を設定する</a>」を参照してください。</p>\n\
</blockquote>\n\
<p>これらの環境変数の詳細については､『Maya ユーザ ガイド』のトピック｢<em>ファイル パス変数</em>｣を参照してください｡</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";