var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>個別ファイルの配布</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>個別ファイルの配布</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a></a></div>\n\
<p>ご使用の Maya アドオンが単一のプラグイン、スクリプト ファイル、アイコンなどの単一のファイルで構成されている場合、一般的にファイル自体を圧縮形式で配布し、エンド ユーザに適切なディレクトリにコピーしてもらうのが合理的です。</p>\n\
<p>たとえば、C++ または Python で作成されたプラグインをインストールする場合、そのプラグイン ファイルを MAYA_PLUG_IN_PATH 環境変数内のいずれかのフォルダにコピーするだけでインストールできます。</p>\n\
<p>複数のユーザが同じプラグインを使用する必要がある場合には、個別にインストールするのではなく、通常はネットワーク ドライブのディレクトリなど、すべてのユーザがアクセスできる共有ディレクトリにインストールするのが望ましいでしょう。これにより、現場の管理者は、後でファイルの新しいバージョンがリリースされたときも非常に簡単に適用できます。</p>\n\
<p>共有フォルダをすべてのユーザに対して有効にするには、すべてのユーザの MAYA_PLUG_IN_PATH に追加する必要があります。既定では、MAYA_PLUG_IN_PATH にはユーザ専用フォルダとシステム全体のフォルダの両方が収められています。システム全体のディレクトリは、パスが固定されたディレクトリや Maya のインストール場所を基準とした相対パスのディレクトリに分割できます。たとえば Linux 上の Maya 2017 では、MAYA_PLUG_IN_PATH 内に次のシステム全体のフォルダが含まれています。</p>\n\
<ul>\n\
<li><span class=\'code\'>/usr/autodesk/userconfig/maya/2017/plug-ins</span></li>\n\
<li><span class=\'code\'>/usr/autodesk/userconfig/maya/plug-ins</span></li>\n\
<li><span class=\'code\'>/usr/autodesk/maya/2017/bin/plug-ins</span></li>\n\
</ul>\n\
<p>最初の 2 つのパスは Maya のインストール場所に関係なく同じですが、3 番目のパスには Maya のインストール先のフォルダ ツリーの最上部である <span class=\'code\'>/usr/autodesk/maya/2017</span> が含まれています。Maya が <span class=\'code\'>/opt/maya2017</span> にインストールされている場合、最初の 2 つのパスは上記のとおり同じになりますが、3 番目のパスは次のようになります。</p>\n\
<ul>\n\
<li>/opt/maya2017/bin/plug-ins</li>\n\
</ul>\n\
<p>このことは、すべてのユーザがプラグインを使用できるようにする方法が、次のようにいくつかあることを意味します。</p>\n\
<ol>\n\
<li>ネットワーク ドライブなどすべてのユーザがアクセスできる共有フォルダに Maya をインストールしてから、Maya のインストール場所を基準とする MAYA_PLUG_IN_PATH フォルダにプラグインをインストールします(上記の 3 番目のパスなど)。</li>\n\
<li>各ユーザのシステムで、MAYA_PLUG_IN_PATH のシステム全体の固定パスのいずれか(上記の先頭 2 つのパスなど)をネットワーク ドライブのようなすべてのユーザがアクセスできる共有フォルダにマップしてから、プラグインをこのフォルダにインストールします。このアプローチでは、Maya のインストール場所が共通の場所でも、各ユーザのマシン上の個別の場所でも問題はありません。</li>\n\
<li>MAYA_PLUG_IN_PATH に提供される既定のフォルダを無視します。この代わりに、すべてのユーザがアクセスできる共有フォルダにプラグインをインストールし、そのフォルダをすべてのユーザの MAYA_PLUG_IN_PATH に明示的に追加します。このようにするには、各ユーザの <span class=\'code\'>Maya.env</span> ファイルを修正するか、システム専用ツールを使用して、Maya の起動前に共有フォルダがすべてのユーザの MAYA_PLUG_IN_PATH に確実に指定されるようにします。</li>\n\
</ol>\n\
<p>これらと同じアプローチは、MEL または Python スクリプト ファイルでも利用できます。ただし、MAYA_PLUG_IN_PATH ではなく、ユーザの MAYA_SCRIPT_PATH 環境変数のフォルダにスクリプトをインストールする必要があります。同様に、アイコンをユーザの XBMLANGPATH 環境変数のフォルダに、プリセットをユーザの MAYA_PRESET_PATH のフォルダにインストールする必要があります。</p>\n\
<blockquote>\n\
<p><strong>ヒント:</strong> 要約すると、前述の 4 つの環境変数は次のとおりです｡</p>\n\
<ul>\n\
<li>MAYA_PLUG_IN_PATH - プラグインを検索するフォルダ</li>\n\
</ul>\n\
</blockquote>\n\
<ul>\n\
<li>MAYA_SCRIPT_PATH - MEL および Python スクリプトを検索するフォルダ</li>\n\
<li>XBMLANGPATH - アイコンを検索するディレクトリ</li>\n\
<li>MAYA_PRESET_PATH - Maya プリセットを検索するフォルダ</li>\n\
</ul>\n\
<p>各環境変数がどのディレクトリに設定されているかを確認するには､次のように Maya スクリプト エディタ(Script Editor) または Maya コマンド ラインで getenv コマンドを使用します｡</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">getenv MAYA_PLUG_IN_PATH\n\
</pre></div><p>希望のディレクトリに環境変数を設定することもできます。これを行うには、<span class=\'code\'>Maya.env</span> ファイルを作成する必要があります。<span class=\'code\'>Maya.env</span> の詳細については、「<a href=\'#!/url=./developer/Setting-up-your-build.html\' title=\'\'>ビルド環境を設定する</a>」を参照してください。</p>\n\
<div class=\'section\'><a></a><h2>関連項目</h2></div>\n\
<ul>\n\
<li><a href=\'#!/url=./developer/Setting-up-your-build.html\' title=\'\'>ビルド環境を設定する</a></li>\n\
<li><a href=\'#!/url=./developer/Installing-Maya-plug-ins.html\' title=\'\'>Maya プラグインのインストール</a></li>\n\
</ul>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";