var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>はじめに</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>はじめに</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a></a></div>\n\
<p>Autodesk® Maya® はオープン プロダクトです。つまり、Autodesk 社外の方でも、既存の機能の変更やまったく新しい機能の追加が実施できます。Maya でこれを行うには 2 つのインタフェースがあります。Maya のコマンドと Maya の API です。これら 2 つのインタフェースで、異なる言語を実装することもできます。</p>\n\
<div class=\'figure\'><img src=\'developer/images/Introduction_API_Commands.png\' title=\'\'></div>\n\
<p>Maya コマンド</p>\n\
<p>次のいずれかの言語を使用してスクリプトを作成します。</p>\n\
<ul>\n\
<li>MEL (Maya Embedded Language): パワフルで習得しやすいスクリプト言語です。Maya コマンドを実行するために使用されます。ほとんどの一般的な操作は、MEL を使用して実行できます。</li>\n\
<li>Python: パワフルで習得しやすいスクリプト言語で、Maya コマンドへのインタフェースを提供します。</li>\n\
</ul>\n\
<p>MEL および Python の概要については、『<strong>Maya ユーザ ガイド</strong>』の「<strong>スクリプティング</strong>」のセクションを参照してください。また、MEL/Python の各コマンドについてのリファレンスは、「<strong>テクニカル ドキュメント</strong>」のセクションを参照してください。</p>\n\
<p>Maya API</p>\n\
<p>次の 3 つの API を使用してプラグインを作成します。</p>\n\
<ul>\n\
<li>C++ API (Application Programmer Interface): MEL や Python よりも優れたパフォーマンスを得ることができます。API を使用すると新しいオブジェクトを Maya に追加でき、そのコードは、MEL を使用して同じタスクを実行した場合より約 10 倍速く実行されます。また、API から MEL コマンドを実行することができます。</li>\n\
<li>Python API: C++ API をベースにしており、API を Python スクリプト言語を通じて使用できます。Python API には、Python API 1.0 および Python API 2.0 という 2 つのバージョンがあります。</li>\n\
<li>.NET API: Maya Python API と同様に、Maya C++ API から生成されます。.NET API のほとんどのクラスには、同じ名前で似たインタフェース(つまり、関数とクラスのセット)を持つ対応するクラスが C++ API にあります。これはプラグインの作成を可能にするシステムであり、Microsoft の .NET テクノロジを使用する Maya の拡張機能です。</li>\n\
</ul>\n\
<p>『Maya 開発者ヘルプ』は、Maya API、Maya Python API、Maya .NET API に関する技術的な概要を提供します。</p>\n\
<div class=\'section\'><a id=\"maya-api-\"></a><h2 id=\"maya-api-\">Maya API の概要</h2></div>\n\
<p>Maya API は Maya への内部アクセスを提供する C++ API であり、Windows、Linux、MacOS などのプラットフォームで使用できます。API を使用して、Maya の機能を拡張するプラグイン、または Maya モデルにアクセスし、操作するコンソール アプリケーションなどのスタンドアローンの 2 つのコード リソースを実装することができます。</p>\n\
<p>プラグインは、以下の 2 つの方法で構築できます。</p>\n\
<ul>\n\
<li>標準的なオペレーティング システムの機能を使用して、Maya にロードされるダイナミック ライブラリ、またはリロケータブル ライブラリとして構築します。プラグインは、ホスト アプリケーションである Maya のシンボル スペースにアクセスすることにより機能します。ロードされたその他のプラグインのシンボル スペースにアクセスすることはできません。</li>\n\
<li>Maya Python API を使用したスクリプトを記述します。</li>\n\
</ul>\n\
<p>Maya Developer Kit では、API を使用したプラグインのサンプルを提供しています。多くのサンプルが C++ と Python の両方のソースコードで提供されています。Maya に両方のバージョンを同時にロードできるようにするには、Python API 1.0 のプラグインでコマンド名の接頭辞とノードに <em>sp</em> (たとえば、spHelix) と表記するようにします。ユーザが、この規則に従う必要はありません。Developer Kit に含まれている Python API 2.0 のサンプルの名前には、<em>py</em> という接頭辞(たとえば、pyBlindDoubleDataCmd)が付いています。</p>\n\
<p>ダイナミック ライブラリを使用する場合、開発に使用したオペレーティング システムにより、プラグインの構築と名前付け方法にさまざまな制約が課されます。コンパイルされたプラグインは、プラットフォームに応じて次のようなファイル拡張子を使用します。</p>\n\
<ul>\n\
<li>Linux: <span class=\'code\'>.so</span></li>\n\
<li>Windows: <span class=\'code\'>.mll</span></li>\n\
<li>MacOS: <span class=\'code\'>.bundle</span></li>\n\
<li>Python プラグイン(すべてのプラットフォーム): <span class=\'code\'>.py</span></li>\n\
</ul>\n\
<p>また、プラグインと API アプリケーションの作成ルールは、プラットフォームによって異なります。「<a href=\'#!/url=./developer/Setting-up-your-build.html\' title=\'\'>ビルド環境を設定する</a>」を参照してください。</p>\n\
<p>Maya API に加え、<strong>Bifröst API</strong> を利用することもできます。これは Maya のインストール フォルダ内にある <span class=\'code\'>bifrostapi</span> フォルダにあります。たとえば、次の場所です。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">C:\\Program Files\\Autodesk\\Bifrost\\Maya2018\\sdk\\include\\bifrostfluids\\bifrostapi\n\
</pre></div><div class=\'section\'><a id=\"developer-kit\"></a><h3 id=\"developer-kit\">Developer Kit</h3></div>\n\
<p>Developer Kit は <a href=\'#!/url=./developer/Maya-API-introduction/https://www.autodesk.com/developmaya/\' title=\'\'>Maya デベロッパー センター</a>から入手できます。開発キットには、インクルード ファイル、ライブラリ、サンプルの主要な 3 つのコンポーネントが含まれます。</p>\n\
<p>Developer Kit は、devkit とも呼ばれます。</p>\n\
<div class=\'section\'><a></a><h4>例</h4></div>\n\
<p>ローカル フォルダに Developer Kit のアーカイブをコピーして解凍すると、<span class=\'code\'>devkitBase</span> という名前のフォルダが作成されます。Maya API のサンプルは <span class=\'code\'>devkitBase\\devkit</span> フォルダに保管されています。このフォルダには、<span class=\'code\'>applications</span> および <span class=\'code\'>plug-ins</span>フォルダが含まれています。<span class=\'code\'>applications</span> フォルダにはスタンドアローン API アプリケーションのサンプルが、<span class=\'code\'>plug-ins</span> フォルダには Maya API プラグインのサンプルが入っています。スタンドアローンやプラグインの構築に使用されるメソッドは、プラットフォームによって異なります。ほとんどの場合、<span class=\'code\'>Makefiles</span> が使用されます。Windows および MacOS には、提供されているサンプルの大半を構築するための IDE ソリューションが用意されています。Maya Developer Kit をインストールして設定する方法については、「<a href=\'#!/url=./developer/Setting-up-your-build.html\' title=\'\'>ビルド環境を設定する</a>」を参照してください。</p>\n\
<p>Python API 1.0 および API 2.0 のサンプルは、ともに <span class=\'code\'>devkitBase\\devkit\\plug-ins\\scripted</span> フォルダ内にあります。Python API 2.0 のサンプルは、そのファイル名に接頭辞 <span class=\'code\'>py</span> が付いていることで識別できます。</p>\n\
<p>Maya のインストール DVD にはコンパイル済みのプラグイン バイナリとアプリケーション バイナリは入っていません。ユーザがビルドする必要があります。Developer Kit のサンプルのビルドの詳細については「<a href=\'#!/url=./developer/Setting-up-your-build.html\' title=\'\'>ビルド環境を設定する</a>」を参照してください。</p>\n\
<div class=\'section\'><a id=\"-\"></a><h4 id=\"-\">インクルード ファイル</h4></div>\n\
<p>ヘッダー ファイルは、<span class=\'code\'>include/maya</span> フォルダにあります。Maya のヘッダー ファイル名は、通常、接頭辞 <span class=\'code\'>M</span> で始まります。特定の種類のヘッダー ファイルでは、M の後の 2 文字がヘッダー ファイルの種類を示します。<span class=\'code\'>Fn</span> は関数セット、<span class=\'code\'>It</span> はイニシエータ、<span class=\'code\'>Px</span> はプロキシ クラスです。この命名規則については、後で詳しく説明します。</p>\n\
<div class=\'section\'><a id=\"tinyxml\"></a><h4 id=\"tinyxml\">TinyXML</h4></div>\n\
<p>Maya では、現在、TinyXML バージョン 2.5.3 が使用されています。</p>\n\
<div class=\'section\'><a></a><h4>ライブラリ</h4></div>\n\
<p>この API は、Maya のさまざまな機能領域に対応するライブラリのセットとしてパッケージ化されています。ライブラリは以下のとおりです。</p>\n\
<p>OpenMaya: ノードとコマンドを定義してプラグインに組み立てるための基本的なクラスが含まれています。</p>\n\
<p>OpenMayaUI: マニピュレータ、コンテキスト、ロケータなどのユーザ インタフェース要素を新規作成するために必要なクラスが含まれています。</p>\n\
<p>OpenMayaAnim: デフォーマやインバース キネマティクス(IK)などのアニメーション用のクラスが含まれています。</p>\n\
<p>OpenMayaFX: Autodesk Dynamics のクラスが含まれています。</p>\n\
<p>OpenMayaRender: レンダリング機能の実行に必要なクラスが含まれています。</p>\n\
<p>これらのライブラリは共有ライブラリなので、多数のプラグインが同時に使用できます。ライブラリは、<span class=\'code\'>lib</span> フォルダにあります。</p>\n\
<div class=\'section\'><a></a><h2>プラグイン対スクリプト</h2></div>\n\
<p>前述のように、プラグインを使って Maya の機能を拡張することができます。たとえば、次のような操作を実行できます。</p>\n\
<ul>\n\
<li>Maya に新しいノード タイプを追加する</li>\n\
<li>Maya に新規コマンドを追加する</li>\n\
<li>詳細なコールバックを追加する(scriptJob のイベントや条件よりも詳細にできます。「テクニカル ドキュメント」セクションにある MEL/Python のコマンド リファレンスのドキュメントで、「scriptJob」を参照してください。)</li>\n\
<li>新しいレンダリング パイプラインなどを追加する</li>\n\
</ul>\n\
<div class=\'section\'><a id=\"c--python-\"></a><h3 id=\"c--python-\">C++ プラグイン対 Python プラグイン</h3></div>\n\
<p>コンパイル済みの C++ プラグインは、プラットフォームや Maya のバージョンごとに異なります。バージョンごと、あるいはプラットフォームごとに個別のプラグインをコンパイルする必要があります。また、コンパイル済みの C++ プラグインは、プラットフォームごとに異なるファイル拡張子を使用します。</p>\n\
<p>Python プラグインはプラットフォーム固有で、使用する API が Maya のバージョン間で一貫している場合は、これもまたバージョン固有になります。</p>\n\
<p>C++ プラグインは Python プラグインよりも高速に動作するため、パフォーマンス重視のプラグインでは C++ プラグインを作成する方が良いでしょう。一般的に、Python プラグインは、コンパイル済み C++ プラグインの 70～80% 程度の速度で実行できます。</p>\n\
<div class=\'section\'><a id=\"python-\"></a><h3 id=\"python-\">Python プラグイン対スクリプト</h3></div>\n\
<p>先に説明したように、Maya で操作を実行する場合には 2 つのインタフェースがあり、Maya のコマンド、または Maya の API を使うことができます。さらに、この両方のインタフェースに対して Python を使用することもできます。Python API を使用してプラグインを作成することも、単にスクリプトを作成することもできます。Maya を拡張するには、Python プラグインを定義するだけで済みます(たとえば、新しいノードを追加したり、新しいコマンド タイプを追加することなどを行えます)。あるいは、<span class=\'code\'>maya.cmds</span> モジュールで行う場合は、スクリプト内で API を使用することができます。Maya Developer Kit の <span class=\'code\'>devkitBase\\devkit\\pythonScripts</span> フォルダにある <span class=\'code\'>widgetHierarchy.py</span> のサンプルを参照してください。このサンプルでは <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_open_maya_u_i.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMayaUI</a></span> モジュールを読み込み、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MQtUtil\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_qt_util.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MQtUtil</a></span> クラスのメソッドを呼び出します。これはプラグインではないため、Python の <span class=\'code\'>execfile</span> コマンドを使って、このスクリプトを直接実行できます。</p>\n\
<div class=\'section\'><a id=\"maya--maya--api\"></a><h3 id=\"maya--maya--api\">Maya のコマンド対 Maya の API</h3></div>\n\
<p>スクリプトとプラグインのどちらを作成すべきか、Maya の API と Maya のコマンドのどちらで操作を実行すべきかを決定する場合に検討することが必要ないくつかの要因について説明します。</p>\n\
<ul>\n\
<li><p>多くの場合、Maya API は、Maya のコマンドよりも高速です。一般に Maya の API は Maya に対して低レベルでアクセスするため、Maya への広範なアクセスを行うことができます。フィルタを使ってグラフ上で反復するようなタスクは、Maya のコマンドを使うよりも Maya の API を使って実行したほうが簡単です。さらに、たとえば、非常に多くの頂点を同時に操作するペイント ツールをプログラムするような場合は、Maya の API を使って大規模なデータセットを処理することが有益です。Python の実装による速度が十分でない場合は、そのプラグインを C++ に移植することができます。</p></li>\n\
<li><p>Python のプラグインと Python のスクリプト(API またはコマンドのいずれかを使用)のどちらを作成すべきかを決定するには、Maya を拡張する必要があるのかどうか、または、そのスクリプトをロード/ロード解除することが必要なのかどうかを考慮してください。</p></li>\n\
</ul>\n\
<div class=\'section\'><a></a><h2>ドキュメント</h2></div>\n\
<p>次のドキュメントのコンポーネントが提供されています。</p>\n\
<ul>\n\
<li>Maya API の技術的な概要(本書)</li>\n\
<li>API クラスの説明</li>\n\
</ul>\n\
<p>この Maya API の技術的基礎知識には、Maya Python API と Maya .NET API のセクションが含まれています。また、C++ API リファレンスのクラスを説明するドキュメントには、C++ と Python API の両方の開発アプローチに関する情報が含まれているため、これらの両方の開発に使用できます。Maya Python API 2.0 リファレンス ドキュメントも利用可能です。</p>\n\
<p>Maya .NET API には、C++ のリファレンス ドキュメントに基づいて作成された Visual Studio の統合ドキュメントも同梱されています。また、このリファレンス ドキュメントの <span class=\'code\'>.chm</span> バージョンを、<a href=\'http://www.autodesk.com/me-sdk-docs\' title=\'\' target=\'_blank\'>http://www.autodesk.com/me-sdk-docs</a> から入手することができます。</p>\n\
<p>関連マニュアルには次のものがあります。</p>\n\
<ul>\n\
<li>『Maya ユーザ ガイド』の「スクリプティング」セクション。「MEL とエクスプレッション」のセクションと「Python」のセクションで構成されます。</li>\n\
<li>「テクニカル ドキュメント」セクション。「MEL コマンド」のリファレンスと「Python コマンド」のリファレンスがあります。</li>\n\
<li>「テクニカル ドキュメント」セクションの「Maya ノードとアトリビュート」のリファレンス。Maya ノードを操作することは、Maya API プログラムにおいて必要事項です。</li>\n\
<li>「<a href=\'#!/url=./developer/What-s-New-What-s-Changed-.html\' title=\'\'>新機能と変更点</a>」。リリースごとに提供されている情報です。</li>\n\
<li>開発者にとって興味のある情報を提供する『リリース ノート』。</li>\n\
</ul>\n\
<p>最初の 4 つの項目は『Maya ヘルプ』からアクセスすることができます。『リリース ノート』は、<a href=\'http://www.autodesk.com/maya-releasenotes-jpn\' title=\'\' target=\'_blank\'>http://www.autodesk.com/maya-releasenotes-jpn</a> で入手できます。</p>\n\
<div class=\'section\'><a></a><h2>その他の要件</h2></div>\n\
<p>Maya API は C++ API なので、以下を理解しておくことが最善でしょう。</p>\n\
<ul>\n\
<li>仮想関数</li>\n\
<li>クラス継承(マルチを含む)</li>\n\
<li>ストリーム クラス</li>\n\
<li>オペレータ メソッド(Maya API にはさまざまなオペレータ メソッドがあります)</li>\n\
</ul>\n\
<p>さらに、プラグイン、またはスタンドアローンを構築するときには、そのリリースに対して推奨されているコンパイラとリンカーを使用する必要があります。この情報は、このドキュメントの「<a href=\'#!/url=./developer/What-s-New-What-s-Changed-.html\' title=\'\'>新機能と変更点</a>」または「<a href=\'#!/url=./developer/Setting-up-your-build.html\' title=\'\'>ビルド環境のセットアップ</a>」で確認できます。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";