var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Maya Python プラグインの Learning Path</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Maya Python プラグインの Learning Path</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"maya-python--learning-path\"></a></div>\n\
<div class=\'section\'><a></a><h2>ようこそ</h2></div>\n\
<p>この Learning Path では、Python を使用して Maya プラグインを開発する上で重要なコンセプト、クラス、および関数の概要を説明します。この Learning Path のトピックを順番に読むことをお勧めしますが、注釈付きのサンプル コードはリファレンス マテリアルとして独立して参照できます。</p>\n\
<blockquote>\n\
<p><strong>注:</strong> この Learning Path では、Maya Python 1.0 と 2.0 の両方の API を使用します。2.0 API は高速化され、より「Python に近い」ものになりましたが、まだ 1.0 のすべてのフィーチャは 2.0 で使用できません。この API と旧式の 1.0 API の違いについては、「<a href=\'#!/url=./developer/Maya-Python-API/Maya-Python-API-2-0.htmlGUID-F50B96F0-A977-42AE-A500-5589BB7FC878\' title=\'\'>Maya Python API 2.0</a>」を参照してください。</p>\n\
</blockquote>\n\
<div class=\'figure\'><img src=\'developer/images/voxelizerScene_redux.png\' title=\'\'></div>\n\
<p><em>「<a href=\'#!/url=./developer/Maya-Python-API/Maya-Python-Plug-in-Learning/Dependency-Graph-Plug-in-Basics/Example-Voxelizer-Node.html\' title=\'\'>100% 以上のボクセル!</a>」</em></p>\n\
<div class=\'section\'><a id=\"python--python-\"></a><h2 id=\"python--python-\">Python スクリプトと Python プラグインの違いは?</h2></div>\n\
<p>始めるにあたって、Maya の Python <strong>スクリプト</strong>と<strong>プラグイン</strong>の違いを理解することが重要です。</p>\n\
<ul>\n\
<li><strong>Python スクリプト</strong>: これらのプログラムは、Maya のインタラクティブなスクリプト エディタ(Script Editor)ウィンドウで実行できます。Python スクリプトは、通常、<span class=\'code\'>maya.cmds</span> モジュールを使用します。このモジュールの機能は、Maya のほとんどの MEL コマンドをエミュレートします。次のインポート ステートメントは、通常、Maya Python スクリプトの先頭にあります。</li>\n\
</ul>\n\
<p><span class=\'code\'>import maya.cmds as cmds</span></p>\n\
<p>この Learning Path では、<span class=\'code\'>maya.cmds</span> モジュールを使用して Python プラグインを実行します。</p>\n\
<blockquote>\n\
<p><strong>注: </strong> <span class=\'code\'>maya.cmds</span> Python モジュールの詳細については、<strong>『Maya ユーザ ガイド』 &gt; 「Technical Documentation」 &gt; 「CommandsPython」</strong>を参照してください。</p>\n\
</blockquote>\n\
<ul>\n\
<li><strong>Python プラグイン</strong>: これらのプログラムは、Maya のプラグイン マネージャによって <span class=\'code\'>C:\\Users\\&lt;username&gt;\\Documents\\maya\\&lt;version&gt;\\plug-ins</span> および <span class=\'code\'>MAYA_PLUG_IN_PATH</span> 環境変数で定義されているフォルダからロードされます。Maya Python プラグインを使用すると、コマンド、ノード、シェーダ、コンストレイント、ファイル トランスレータ、デフォーマなどのカスタマイズ可能な要素を定義できます。Maya の Python プラグインは、Maya の C++ API に基づく、複数の <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"OpenMaya\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_open_maya.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMaya</a></span> モジュールを使用します。</li>\n\
</ul>\n\
<p>2.0:</p>\n\
<p><span class=\'code\'>import maya.api.OpenMaya       as <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_open_maya.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMaya</a>        # Common classes import maya.api.OpenMayaAnim   as <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaAnim\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_open_maya_anim.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMayaAnim</a>    # Animation classes import maya.api.OpenMayaRender as <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_open_maya_render.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMayaRender</a>  # Rendering classes import maya.api.OpenMayaUI     as <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_open_maya_u_i.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMayaUI</a>      # User interface classes</span></p>\n\
<p>1.0:</p>\n\
<p><span class=\'code\'>import maya.OpenMaya       as <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_open_maya.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMaya</a>        # Common classes import maya.OpenMayaMPx    as OpenMayaMPx     # Classes from which to inherit import maya.OpenMayaAnim   as <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaAnim\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_open_maya_anim.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMayaAnim</a>    # Animation classes import maya.OpenMayaFX     as OpenMayaFX      # Effect classes (hair, particles, fluids) import maya.OpenMayaRender as <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaRender\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_open_maya_render.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMayaRender</a>  # Rendering classes import maya.OpenMayaUI     as <a href=\"javascript:void(0)\" data-symbol=\"OpenMayaUI\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/namespace_open_maya_u_i.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">OpenMayaUI</a>      # User interface classes import maya.OpenMayaCloth  as OpenMayaCloth   # Cloth classes</span></p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";