var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../../../scripts/prettify.js\"></script><script src=\"../../../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>シーン グラフを照会する</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>シーン グラフを照会する</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"-\"></a></div>\n\
<p>このトピックでは、Maya のシーン エレメント構成の基本について説明します。</p>\n\
<div class=\'section\'><a id=\"dag\"></a><h2 id=\"dag\">無閉路有向グラフ(DAG)</h2></div>\n\
<p>Maya のシーン グラフは、通常は「<strong>無閉路有向グラフ</strong>」または <strong>DAG</strong> と呼ばれます。DAG は、実際には、シェーダ、デフォーマ、コンストレイントなど、非常に多様なノード タイプを含む、ディペンデンシー グラフ**と呼ばれるかなり大きなグラフのサブセットです。詳細については、次のセクション「<a href=\'#!/url=./developer/Maya-Python-API/Maya-Python-Plug-in-Learning/Dependency-Graph-Plug-in-Basics.html\' title=\'\'>ディペンデンシーグラフ プラグインの基本</a>」を参照してください。ここでは、2 つの方法のいずれかで分類できる DAG ノードにフォーカスします。</p>\n\
<ol>\n\
<li><strong>トランスフォーム ノード(<span class=\'code\'>MFn.kTransform</span>):</strong> このノード タイプは、下階層にあるすべてのオブジェクトに影響するローカルの 4x4 変換行列を定義します。この変換データは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnTransform\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_transform.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_transform.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnTransform</a></span> 関数セットによって操作します。トランスフォーム ノードは、シーン エレメントをグループ化する目的で他のトランスフォーム ノードを子として持つことができます。</li>\n\
<li><strong>シェイプ ノード(<span class=\'code\'>MFn.kMesh</span>、<span class=\'code\'>MFn.kCamera</span>、<span class=\'code\'>MFn.kLight</span> ... ):</strong> このノード タイプには、メッシュの頂点など、シーン エレメントの実際のジオメトリ情報が含まれます。シェイプ ノードは、常にトランスフォーム ノードを親として持ちます。</li>\n\
</ol>\n\
<p>次の図は、基本的なシーンの簡素化された無閉路有向グラフ(DAG)を表します。<span class=\'code\'>world</span> ノードは、シーンのルートを表します。緑色の円は、トランスフォーム ノード(<span class=\'code\'>kTransform</span>)に対応しており、シーン内のシェイプの位置決めが可能です。シェイプ ノードは、青色の円で示されます。この DAG では、<span class=\'code\'>perspShape</span> はシーン内のカメラ、<span class=\'code\'>pCubeShape1</span> はシーン内のキュービック メッシュ、<span class=\'code\'>pointLightShape1</span> はシーン内のポイント ライトをそれぞれ表します。<span class=\'code\'>pointLight1</span> トランスフォーム ノードは、<span class=\'code\'>pCube1</span> トランスフォーム ノードの子です。つまり、<span class=\'code\'>pCube1</span> トランスフォーム ノードが移動された場合には、ポイント ライトも移動します。</p>\n\
<div class=\'figure\'><img src=\'developer/images/MayaSceneGraph.png\' title=\'\'></div>\n\
<blockquote>\n\
<p><strong>注:</strong> 通常、シェイプ ノードはその下に子を持つことはできません。この規則の例外は、<em>underworld</em> と呼ばれる特別な状況です。<em>underworld</em> は、そのルートがシェイプ ノードの子としてアタッチされる DAG サブグラフです。この <em>underworld</em> グラフは、NURBS カーブや NURBS サーフェスのコントロール ポイントおよび依存関係を定義します。</p>\n\
</blockquote>\n\
<div class=\'section\'><a id=\"dag-\"></a><h2 id=\"dag-\">DAG パス</h2></div>\n\
<p>DAG 内の特定のシーン エレメントの位置は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagPath</a></span> オブジェクトによって指定されます。</p>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagPath</a></span> は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath.node()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#a34b606120f12457f3128057a7b4740e3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagPath.node()</a></span> を使用して DAG で対応する <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MObject\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_object.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_object.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MObject</a></span> を返すことができます。パス自体を拡張してシェイプ ノード(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath.extendToShape()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#a6bbdc34b5bfd9747bfc59ad21771f7c6&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagPath.extendToShape()</a></span>)を含めるか、最も低いトランスフォーム ノード(<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath.transform()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#a252aef07d234fb4f316d4fb32a41ea8b&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagPath.transform()</a></span>)を返していくつかの便利な関数を指定することができます。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath.fullPathName()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#a8ad464725ea36f88c4608d5525b1cde3&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagPath.fullPathName()</a></span> 関数は、指定されたノードまでの DAG パスの文字列表現を返します。文字列表現は、DAG の名前のないルートから始まる、ノード名をパイプ(「<span class=\'code\'>|</span>」)で区切ったシーケンスとしての書式をとります。上の図では、ルート <span class=\'code\'>world</span> ノードから <span class=\'code\'>pointLightShape1</span> までのパスの文字列表現は、「<span class=\'code\'>|pCube1|pointLight1|pointLightShape1</span>」のようになります(ルート ノードに名前がないことに注目してください)。</p>\n\
<p>メモリの消費を減らすために、密度が特別に高いメッシュなど、複雑なシェイプをシーン グラフの複数の場所で<em>インスタンス化</em>できます。つまり、コピーすることなく、同じシェイプがシェイプの複数の位置にくるようにできます。これを実現するために、DAG 内の複数のトランスフォーム ノードを同じシェイプ ノードの親にすることができます。そのようにして、1 つのシェイプ ノードに DAG のルートからの複数のパスを持たせることができます。インスタンス化されたシェイプ ノードを特定するために、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath.isInstanced()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#accfb22081f7c3c5421741f68ffd16378&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagPath.isInstanced()</a></span> および <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MDagPath.instanceNumber()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html#a0ef64fd5f3cbf426aed9c78ad40f9f85&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagPath.instanceNumber()</a></span> などの関数を使用できます。</p>\n\
<div class=\'section\'><a id=\"-\"></a><h2 id=\"-\">シーン グラフのトラバース</h2></div>\n\
<p>シーン グラフは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dag.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItDag</a></span> オブジェクトを使用してトラバースできます。DAG はディペンデンシー グラフのサブセットであるため、必要に応じて <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDependencyGraph\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dependency_graph.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dependency_graph.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItDependencyGraph</a></span> オブジェクトを使用できます。</p>\n\
<p>先頭に <span class=\'code\'>MIt</span> が追加されたクラスは<em>イテレータ</em>と呼ばれ、コレクション内の各オブジェクトを検査する目的で使用できます。この例では、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dag.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItDag</a></span> によってシーン内の DAG ノードを反復できます。以下のサンプル コードでは、DAG イテレータを作成します。このイテレータが、ルートからシーンのトラバースを開始して、深さ優先で各ノードに移動します。<span class=\'code\'>OpenMaya.MFn.kInvalid</span> パラメータにより、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_dag.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItDag</a></span> オブジェクトがどのノード タイプもフィルタしなくなります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">dagIterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MItDag</a>( OpenMaya.MItDag.kDepthFirst, OpenMaya.MFn.kInvalid )\n\
\n\
# This reference to the <a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnDagNode</a> function set will be needed\n\
# to obtain information about the DAG objects.\n\
dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnDagNode</a>()\n\
</pre></div><p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDag.isDone()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html#afce691ae1306e9ca23e6e889dec9b54b&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItDag.isDone()</a></span> 関数により、検査すべきオブジェクトが残っているかどうかを判別します。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDag.currentItem()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html#a03b48b8d2d5b0bef88a48a362eac0eec&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItDag.currentItem()</a></span> 関数は、イテレータの現在の DAG オブジェクトを返します。この DAG オブジェクトのルートからの相対的な深度は、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDag.depth()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html#a6dac1beb1726dcab80704d0c921079ce&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItDag.depth()</a></span> を使用して取得できます。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDag.next()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html#a7e119c3d34279c19f6f26780981f39b9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItDag.next()</a></span> を呼び出すと、イテレータの内部状態が次の項目に進みますが、DAG オブジェクトは返しません。これを唯一達成できるのは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDag.currentItem()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html#a03b48b8d2d5b0bef88a48a362eac0eec&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItDag.currentItem()</a></span> を使用する方法です。これ以上反復を続ける項目がない場合には、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItDag.isDone()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html#afce691ae1306e9ca23e6e889dec9b54b&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItDag.isDone()</a></span> 関数によって <span class=\'code\'>True</span> が返されます。したがって、シーン グラフをトラバースする簡易な while ループを作成できます。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># Traverse the scene.\n\
while( not dagIterator.isDone() ):\n\
\n\
    # Obtain the current item.\n\
    dagObject = dagIterator.currentItem()\n\
\n\
    # Extract the depth of the DAG object.\n\
    depth = dagIterator.depth()\n\
            \n\
    # Make our <a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnDagNode</a> function set operate on the current DAG object.\n\
    dagNodeFn.setObject( dagObject )\n\
                       \n\
    # Extract the DAG object&#39;s name.\n\
    name = dagNodeFn.name()\n\
            \n\
    print name + &#39; (&#39; + dagObject.apiTypeStr() + &#39;) depth: &#39; + str( depth )\n\
    \n\
    # Iterate to the next item.\n\
    dagIterator.next()\n\
<blockquote>\n\
</blockquote></pre></div><p><strong>注:</strong> <em>関数セット</em>(例: <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnDagNode</a></span>)を使用する方法については、「<a href=\'#!/url=./developer/Maya-Python-API/Maya-Python-Plug-in-Learning/Command-Plug-in-Basics/Creating-and-Manipulating.html\' title=\'\'>オブジェクトの作成と操作</a>」を参照してください。</p>\n\
\n\
<div class=\'section\'><a id=\"-\"></a><h2 id=\"-\">選択したシーン エレメントの検査</h2></div>\n\
<p>Maya のユーザ インタフェース(またはスクリプト)を使用してオブジェクトを選択すると、オブジェクトがグローバル <em>アクティブ セレクション リスト</em>に追加され、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGlobal.getActiveSelectionList()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a066fc800bd29827c3707102018d72ad9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MGlobal.getActiveSelectionList()</a></span> を使用してアクセスできるようになります。スタティック クラス <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MGlobal\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_global.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MGlobal</a></span> は、Maya アプリケーション、ロギング、オブジェクト選択、コマンド実行、3D ビュー(シーンのアップ軸を含む)、およびモデル操作に関する各種の関数を含んでいます。</p>\n\
<p>以下のコードは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MSelectionList</a></span> オブジェクトを投入することによって、アクティブ セレクション リストを取得する方法を例示しています。</p>\n\
<p>Python API 2.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">selectionList = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getActiveSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a066fc800bd29827c3707102018d72ad9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MGlobal.getActiveSelectionList</a>()\n\
</pre></div><p>Python API 1.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">selectionList = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MSelectionList</a>()\n\
<a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getActiveSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a066fc800bd29827c3707102018d72ad9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MGlobal.getActiveSelectionList</a>( selectionList )\n\
</pre></div><p>この例では、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItSelectionList</a></span> のインスタンスを使用してセレクション リストを反復します。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItSelectionList</a></span> のコンストラクタを使用してフィルタを指定することにより、特定のタイプのオブジェクトを反復できます。以下の例では、<span class=\'code\'>MFn.kDagNode</span> パラメータを指定します。それにより、この例のイテレータは、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnDagNode</a></span> 関数と互換性があるオブジェクトに対してフィルタを実行します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">iterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MItSelectionList</a>( selectionList, OpenMaya.MFn.kDagNode )\n\
</pre></div><p>Python API 2.0 で、選択リストを使用して、シーン内のすべてのノードを最初に選択し、各項目のイテレータに <span class=\'code\'>getDagPath()</span> を呼び出すことによって、シーン グラフ全体を繰り返し処理することができます。たとえば、次のようになります。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnDagNode</a>()\n\
 \n\
cmds.select(all=True)\n\
selectionList = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getActiveSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a066fc800bd29827c3707102018d72ad9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MGlobal.getActiveSelectionList</a>()\n\
if sList.length()&gt;0:\n\
    iterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MItSelectionList</a>(selectionList, OpenMaya.MFn.kDagNode)\n\
    while not iterator.isDone():  \n\
        print iterator.getDagPath()\n\
        iterator.next()\n\
</pre></div><div class=\'section\'><a id=\"--dag-\"></a><h2 id=\"--dag-\">プラグイン コマンドの例: DAG パスを出力する</h2></div>\n\
<p><strong>ファイル名:</strong> <span class=\'code\'>printPaths.py</span></p>\n\
<p><strong>スクリプト エディタ出力の例:</strong></p>\n\
<div class=\'figure\'><img src=\'developer/images/printPaths.png\' title=\'\'></div>\n\
<p><strong>プログラムの概要:</strong> 以下のプラグイン コードによって、<span class=\'code\'>printPaths()</span> コマンドが作成されます。このコマンドの動作は、<em>アクティブ セレクション リスト</em> に DAG オブジェクトが含まれるかどうかに応じて変わります。1 つまたは複数の DAG オブジェクトが選択されている場合、各オブジェクトの名前、タイプ、DAG パス、および互換性のある関数セット タイプがスクリプト エディタに出力されます。そうでない場合には、DAG ノードの名前およびタイプを使用して、シーン グラフが出力されます。</p>\n\
<p>Python API 2.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># pyPrintPaths.py\n\
\n\
import sys\n\
import maya.cmds as cmds\n\
import maya.api.OpenMaya as OpenMaya\n\
\n\
def maya_useNewAPI():\n\
    &quot;&quot;&quot;\n\
    The presence of this function tells Maya that the plugin produces, and\n\
    expects to be passed, objects created using the Maya Python API 2.0.\n\
    &quot;&quot;&quot;\n\
    pass\n\
    \n\
kPluginCmdName = &#39;pyPrintPaths&#39;\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class printPathsCmd(<a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MPxCommand</a>):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MPxCommand.__init__\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_px_command.html#a0e33c57b86f794759092176b16cc0b44&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MPxCommand.__init__</a>(self)\n\
        \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; \n\
        Print the DAG paths of the selected objects.\n\
        If no DAG objects are selected, print the entire\n\
        scene graph.\n\
        &#39;&#39;&#39;\n\
        \n\
        # Populate the <a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MSelectionList</a> with the currently selected\n\
        # objects using the static function MGlobal.getActiveSelectionList().\n\
        \n\
        #selectionList = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MSelectionList</a>()\n\
        selectionList = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getActiveSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a066fc800bd29827c3707102018d72ad9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MGlobal.getActiveSelectionList</a>()\n\
        \n\
        # This selection list can contain more than just scene elements (DAG nodes),\n\
        # so we must create an iterator over this selection list (<a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItSelectionList</a>), \n\
        # and filter for objects compatible with the <a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnDagNode</a> function set (MFn.kDagNode).\n\
        iterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MItSelectionList</a>( selectionList, OpenMaya.MFn.kDagNode )\n\
        \n\
        if iterator.isDone():\n\
            # Print the whole scene if there are no DAG nodes selected.\n\
            print &#39;=====================&#39;\n\
            print &#39; SCENE GRAPH (DAG):  &#39;\n\
            print &#39;=====================&#39;\n\
            self.printScene()\n\
        else:\n\
            # Print the paths of the selected DAG objects. \n\
            print &#39;=======================&#39;\n\
            print &#39; SELECTED DAG OBJECTS: &#39;\n\
            print &#39;=======================&#39;\n\
            self.printSelectedDAGPaths( iterator )\n\
    \n\
    def printSelectedDAGPaths(self, pSelectionListIterator):\n\
        &#39;&#39;&#39; Print the DAG path(s) of the selected object(s). &#39;&#39;&#39;\n\
        \n\
        # Create an <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagPath</a> object which will be populated on each iteration.\n\
        dagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        \n\
        # Obtain a reference to MFnDag function set to print the name of the DAG object\n\
        dagFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnDagNode</a>()\n\
        \n\
        \n\
        \n\
        # Perform each iteration.\n\
        while( not pSelectionListIterator.isDone() ):\n\
            \n\
            # Populate our <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagPath</a> object. This will likely provide\n\
            # us with a Transform node.\n\
            dagPath = pSelectionListIterator.getDagPath()\n\
            try:\n\
                # Attempt to extend the path to the shape node.\n\
                dagPath.extendToShape()\n\
            except Exception as e:\n\
                # Do nothing if this operation fails.\n\
                pass\n\
            \n\
            # Obtain the name of the object.\n\
            dagObject = dagPath.node()\n\
            dagFn.setObject( dagObject )\n\
            name = dagFn.name()\n\
            \n\
            # Obtain the compatible function sets for this DAG object.\n\
            # These values refer to the enumeration values of <a href=\"javascript:void(0)\" data-symbol=\"MFn\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFn</a>\n\
            fntypes = []\n\
            fntypes = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getFunctionSetList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a89e813abc5d6f2fe65755bb0737aa628&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MGlobal.getFunctionSetList</a>( dagObject )\n\
            \n\
            # Print the DAG object information.\n\
            print name + &#39; (&#39; + dagObject.apiTypeStr + &#39;)&#39;\n\
            print &#39;\\tDAG path: [&#39; + str( dagPath.fullPathName() ) + &#39;]&#39;\n\
            print &#39;\\tCompatible function sets: &#39; + str( fntypes )\n\
            \n\
            # Advance to the next item\n\
            pSelectionListIterator.next()\n\
        \n\
        print &#39;=====================&#39;         \n\
            \n\
    def printScene(self):\n\
        &#39;&#39;&#39; Traverse and print the elements in the scene graph (DAG)  &#39;&#39;&#39;\n\
        \n\
        # Create a function set which we will re-use throughout our scene graph traversal.\n\
        dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnDagNode</a>()\n\
        \n\
        # Create an iterator to traverse the scene graph starting at the world node\n\
        # (the scene&#39;s origin). We use a depth-first traversal, and we do not filter for\n\
        # any scene elements, as indicated by the &#39;OpenMaya.MFn.kInvalid&#39; parameter.\n\
        dagIterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MItDag</a>( OpenMaya.MItDag.kDepthFirst,\n\
                                       OpenMaya.MFn.kInvalid )\n\
       \n\
        # Traverse the scene.\n\
        while( not dagIterator.isDone() ):\n\
            \n\
            # Obtain the current item.\n\
            dagObject = dagIterator.currentItem()\n\
            depth = dagIterator.depth()\n\
            \n\
            # Make our <a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnDagNode</a> function set operate on the current DAG object.\n\
            dagNodeFn.setObject( dagObject )\n\
                       \n\
            # Extract the DAG object&#39;s name.\n\
            name = dagNodeFn.name()\n\
            \n\
            # Generate our output by first incrementing the tabs based on the depth\n\
            # of the current object. This formats our output nicely.\n\
            output = &#39;&#39;\n\
            for i in range( 0, depth ):\n\
                output += &#39;\\t&#39;\n\
                \n\
            output += name + &#39; (&#39; + dagObject.apiTypeStr + &#39;)&#39;\n\
            print output\n\
            \n\
            # Increment to the next item.\n\
            dagIterator.next()\n\
        \n\
        print &#39;=====================&#39;\n\
\n\
    \n\
\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################       \n\
def cmdCreator():\n\
    &#39;&#39;&#39; Creates an instance of our command class. &#39;&#39;&#39;\n\
    return printPathsCmd() \n\
    \n\
def initializePlugin(mobject):\n\
    &#39;&#39;&#39; Initializes the plug-in.&#39;&#39;&#39;\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to register command: %s\\n&quot; % kPluginCmdName )\n\
\n\
def uninitializePlugin(mobject):\n\
    &#39;&#39;&#39; Uninitializes the plug-in &#39;&#39;&#39;\n\
    mplugin = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnPlugin\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_plugin.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnPlugin</a>( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to unregister command: %s\\n&quot; % kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39;\n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( &#39;pyPrintPaths.py&#39; )\n\
cmds.pyPrintPaths()\n\
 \n\
&#39;&#39;&#39;\n\
</pre></div><p>Python API 1.0:</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\"># printPaths.py\n\
\n\
import sys\n\
import maya.OpenMayaMPx as OpenMayaMPx\n\
import maya.OpenMaya as OpenMaya\n\
\n\
kPluginCmdName = &#39;printPaths&#39;\n\
\n\
##########################################################\n\
# Plug-in \n\
##########################################################\n\
class printPathsCmd(OpenMayaMPx.MPxCommand):\n\
    \n\
    def __init__(self):\n\
        &#39;&#39;&#39; Constructor. &#39;&#39;&#39;\n\
        OpenMayaMPx.MPxCommand.__init__(self)\n\
        \n\
    def doIt(self, args):\n\
        &#39;&#39;&#39; \n\
        Print the DAG paths of the selected objects.\n\
        If no DAG objects are selected, print the entire\n\
        scene graph.\n\
        &#39;&#39;&#39;\n\
        \n\
        # Populate the <a href=\"javascript:void(0)\" data-symbol=\"MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MSelectionList</a> with the currently selected\n\
        # objects using the static function MGlobal.getActiveSelectionList().\n\
        selectionList = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MSelectionList</a>()\n\
        <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getActiveSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a066fc800bd29827c3707102018d72ad9&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MGlobal.getActiveSelectionList</a>( selectionList )\n\
        \n\
        # This selection list can contain more than just scene elements (DAG nodes),\n\
        # so we must create an iterator over this selection list (<a href=\"javascript:void(0)\" data-symbol=\"MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MItSelectionList</a>), \n\
        # and filter for objects compatible with the <a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnDagNode</a> function set (MFn.kDagNode).\n\
        iterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItSelectionList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_selection_list.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MItSelectionList</a>( selectionList, OpenMaya.MFn.kDagNode )\n\
        \n\
        if iterator.isDone():\n\
            # Print the whole scene if there are no DAG nodes selected.\n\
            self.printScene()\n\
        else:\n\
            # Print the paths of the selected DAG objects. \n\
            self.printSelectedDAGPaths( iterator )\n\
    \n\
    def printSelectedDAGPaths(self, pSelectionListIterator):\n\
        &#39;&#39;&#39; Print the DAG path(s) of the selected object(s). &#39;&#39;&#39;\n\
        \n\
        # Create an <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagPath</a> object which will be populated on each iteration.\n\
        dagPath = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MDagPath</a>()\n\
        \n\
        # Obtain a reference to MFnDag function set to print the name of the DAG object\n\
        dagFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnDagNode</a>()\n\
        \n\
        print &#39;=======================&#39;\n\
        print &#39; SELECTED DAG OBJECTS: &#39;\n\
        print &#39;=======================&#39;\n\
        \n\
        # Perform each iteration.\n\
        while( not pSelectionListIterator.isDone() ):\n\
            \n\
            # Populate our <a href=\"javascript:void(0)\" data-symbol=\"MDagPath\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_dag_path.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_dag_path.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MDagPath</a> object. This will likely provide\n\
            # us with a Transform node.\n\
            pSelectionListIterator.getDagPath( dagPath )\n\
            try:\n\
                # Attempt to extend the path to the shape node.\n\
                dagPath.extendToShape()\n\
            except Exception as e:\n\
                # Do nothing if this operation fails.\n\
                pass\n\
            \n\
            # Obtain the name of the object.\n\
            dagObject = dagPath.node()\n\
            dagFn.setObject( dagObject )\n\
            name = dagFn.name()\n\
            \n\
            # Obtain the compatible function sets for this DAG object.\n\
            # These values refer to the enumeration values of <a href=\"javascript:void(0)\" data-symbol=\"MFn\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFn</a>\n\
            fntypes = []\n\
            <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MGlobal.getFunctionSetList\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_global.html#a89e813abc5d6f2fe65755bb0737aa628&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MGlobal.getFunctionSetList</a>( dagObject, fntypes )\n\
            \n\
            # Print the DAG object information.\n\
            print name + &#39; (&#39; + dagObject.apiTypeStr() + &#39;)&#39;\n\
            print &#39;\\tDAG path: [&#39; + str( dagPath.fullPathName() ) + &#39;]&#39;\n\
            print &#39;\\tCompatible function sets: &#39; + str( fntypes )\n\
            \n\
            # Advance to the next item\n\
            pSelectionListIterator.next()\n\
        \n\
        print &#39;=====================&#39;\n\
            \n\
            \n\
    def printScene(self):\n\
        &#39;&#39;&#39; Traverse and print the elements in the scene graph (DAG)  &#39;&#39;&#39;\n\
        \n\
        # Create a function set which we will re-use throughout our scene graph traversal.\n\
        dagNodeFn = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MFnDagNode</a>()\n\
        \n\
        # Create an iterator to traverse the scene graph starting at the world node\n\
        # (the scene&#39;s origin). We use a depth-first traversal, and we do not filter for\n\
        # any scene elements, as indicated by the &#39;OpenMaya.MFn.kInvalid&#39; parameter.\n\
        dagIterator = <a href=\"javascript:void(0)\" data-symbol=\"OpenMaya.MItDag\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_it_dag.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">OpenMaya.MItDag</a>( OpenMaya.MItDag.kDepthFirst,\n\
                                       OpenMaya.MFn.kInvalid )\n\
\n\
        print &#39;=====================&#39;\n\
        print &#39; SCENE GRAPH (DAG):  &#39;\n\
        print &#39;=====================&#39;\n\
        \n\
        # Traverse the scene.\n\
        while( not dagIterator.isDone() ):\n\
            \n\
            # Obtain the current item.\n\
            dagObject = dagIterator.currentItem()\n\
            depth = dagIterator.depth()\n\
            \n\
            # Make our <a href=\"javascript:void(0)\" data-symbol=\"MFnDagNode\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;},{&quot;path&quot;:&quot;py_ref/class_open_maya_1_1_m_fn_dag_node.html&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../../../&quot;}]\">MFnDagNode</a> function set operate on the current DAG object.\n\
            dagNodeFn.setObject( dagObject )\n\
                       \n\
            # Extract the DAG object&#39;s name.\n\
            name = dagNodeFn.name()\n\
            \n\
            # Generate our output by first incrementing the tabs based on the depth\n\
            # of the current object. This formats our output nicely.\n\
            output = &#39;&#39;\n\
            for i in range( 0, depth ):\n\
                output += &#39;\\t&#39;\n\
                \n\
            output += name + &#39; (&#39; + dagObject.apiTypeStr() + &#39;)&#39;\n\
            print output\n\
            \n\
            # Increment to the next item.\n\
            dagIterator.next()\n\
        \n\
        print &#39;=====================&#39;\n\
\n\
\n\
##########################################################\n\
# Plug-in initialization.\n\
##########################################################       \n\
def cmdCreator():\n\
    &#39;&#39;&#39; Creates an instance of our command class. &#39;&#39;&#39;\n\
    return OpenMayaMPx.asMPxPtr( printPathsCmd() )\n\
    \n\
def initializePlugin(mobject):\n\
    &#39;&#39;&#39; Initializes the plug-in.&#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.registerCommand( kPluginCmdName, cmdCreator )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to register command: %s\\n&quot; % kPluginCmdName )\n\
\n\
def uninitializePlugin(mobject):\n\
    &#39;&#39;&#39; Uninitializes the plug-in &#39;&#39;&#39;\n\
    mplugin = OpenMayaMPx.MFnPlugin( mobject )\n\
    try:\n\
        mplugin.deregisterCommand( kPluginCmdName )\n\
    except:\n\
        sys.stderr.write( &quot;Failed to unregister command: %s\\n&quot; % kPluginCmdName )\n\
\n\
##########################################################\n\
# Sample usage.\n\
##########################################################\n\
&#39;&#39;&#39;\n\
# Copy the following lines and run them in Maya&#39;s Python Script Editor:\n\
\n\
import maya.cmds as cmds\n\
cmds.loadPlugin( &#39;printPaths.py&#39; )\n\
cmds.printPaths()\n\
 \n\
&#39;&#39;&#39;\n\
</pre></div>      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";