var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>Intel Threading Building Blocks</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>Intel Threading Building Blocks</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"intel-threading-building-blocks\"></a></div>\n\
<div class=\'section\'><a></a><h2>概要</h2></div>\n\
<p>Intel® Threading Building Blocks (TBB)は、スレッド化用の比較的新しい高レベルの API です。TBB は、スレッドの概念をタスクの概念に置き換え、ユーザによって定義され、キューに入れられます。次に、TBB はこれらのタスクをスレッドに効率的にマップします。</p>\n\
<p>TBB は Maya がサポートするすべてのプラットフォームで使用できます。for、while、reduce、sort などの操作に共通の機能のラッパ(wrapper)を提供します。また、アトミック要素であるスケーラブルなメモリ アロケータ(malloc などのアロケータはグローバル ヒープにアクセスし、操作をロックするため、多数のスレッドがメモリを使用すると競合が発生)も提供します。最後に、リスト、キュー、ハッシュ マップなどの STL に基づいたスレッドセーフなコンテナがあります。これらのスレッドセーフなコンテナは通常、内部ロックが必要なため、通常のコンテナよりもシングル スレッド化のパフォーマンスが低くなります。したがって、スレッドセーフが必要な場合にのみ使用することをお勧めします。</p>\n\
<p>タスクベースのアプローチにより、OpenMP で発生する<strong>オーバーサブスクリプション</strong>の問題は回避されます。 特に、Maya の評価マネージャを使用する際にオーバーサブスクリプションに問題が発生する場合があります。</p>\n\
<div class=\'section\'><a id=\"tbb-\"></a><h2 id=\"tbb-\">TBB の利点と欠点</h2></div>\n\
<p>TBB は OpenMP よりも高レベルのライブラリであり、複雑になった代わりに柔軟性が向上しています。並列コードは、OpenMP よりも侵入性の高い個別のクラスに抽出する必要があります。</p>\n\
<p>タスクベースのアプローチにより、OpenMP で発生する<strong>オーバーサブスクリプション</strong>の問題は回避されます。 特に、Maya の評価マネージャを使用する際にオーバーサブスクリプションに問題が発生する場合があります。Maya では複数の場所で TBB を利用しており、一部では OpenMP のオーバーサブスクリプションを回避し、別の一部では高レベルのアルゴリズムとコンテナを利用しています。スレッドセーフなクロスプラットフォーム要素とコンテナを作成することは非常に困難です。専用のサード パーティ製ライブラリを使用すると、開発者はスレッド化インフラストラクチャの構築に煩わされずに特定のアプリケーションの最適化に専念できます。</p>\n\
<p>TBB は Maya によって使用されますが、プラグイン作成者が直接アクセスできる方法では公開されていません。プラグインで TBB を使用するには、ライセンスを取得する必要があります。Maya プラグインをスレッド化する場合、TBB の使用に関する要件はありませんが、Maya API ではライセンスがなくても間接的にプラグインに TBB を利用できます。詳細については、<a href=\'#!/url=./developer/Multithreading-plug-ins/Threading-and-Maya.html\' title=\'\'>スレッド化と Maya</a> を参照してください。</p>\n\
<p>TBB では、バージョンの互換性が重要です。Maya 2018 では、TBB バージョン 4.4 Update 6 を使用する必要があります。Maya に同梱されている互換性のある TBB 再分配可能ファイルで TBB を利用できます｡</p>\n\
<p>また、TBB の Web サイト(<a href=\'http://threadingbuildingblocks.org/download#stable-releases\' title=\'\' target=\'_blank\'>http://threadingbuildingblocks.org/download#stable-releases</a>)から対応する製品版リリースをダウンロードすることができます。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";