var topic = "<!-- saved from url=(0024)http://docs.autodesk.com -->\n\
<html>\n\
   <head>\n\
<link href=\"../../style/prettify.css\" type=\"text/css\" rel=\"stylesheet\">\n\
<script type=\"text/javascript\" src=\"../../scripts/prettify.js\"></script><script src=\"../../scripts/lib/jquery-1.11.1.min.js\" type=\"text/javascript\"></script><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"><meta http-equiv=\"Content-Style-Type\" content=\"text/css\"><meta name=\"generator\" content=\"pandoc\"><meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\"><script type=\"text/javascript\" src=\"../../scripts/utils/adsk.redirect.js\"></script>\n\
      <title>GLSL シェーダのトラブルシューティング</title>\n\
   <meta name=\"topic-subtype\" content=\"C++\"></head>\n\
   <body height=\"100%\"><div class=\"body_content\" id=\"body-content\"><style type=\"text/css\">code{white-space: pre;}</style><script>$(document).ready(function() { yepnope.injectJs(\"./scripts/multireflink.js\"); });</script><script>$(document).ready(function () { prettyPrint(); } );</script><script></script><script></script><div id=\"reflinkdiv\"></div>\n\
      <div>\n\
         <div class=\"head\">\n\
            <h1>GLSL シェーダのトラブルシューティング</h1>\n\
         </div>\n\
\n\
<div class=\'section\'><a id=\"glsl-\"></a></div>\n\
<div class=\'section\'><a></a><h2>問題</h2></div>\n\
<p><span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getEffectsFileShader()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a581c659670f0e3168750382c61a91a25&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getEffectsFileShader()</a></span> または <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getEffectsBufferShader()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#ad99e1c36c00ccaf3ea0c7fe0599557f8&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getEffectsBufferShader()</a></span> を使用して <span class=\'code\'>.ogsfx</span> シェーダ インスタンスをロードするときに、シェーダがビューポートにレンダリングされず、エラーが表示されません。</p>\n\
<p>どうすればシェーダ コンパイル エラーを取得できますか?</p>\n\
<div class=\'section\'><a></a><h2>解決方法</h2></div>\n\
<p><span class=\'code\'>.ogsfx</span> シェーダをロードするときに、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getEffectsFileShader()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a581c659670f0e3168750382c61a91a25&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getEffectsFileShader()</a></span> を呼び出した場合、エラーは作成時ではなくバインド時に起こります。<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderInstance.bind()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;py_ref/class_open_maya_render_1_1_m_shader_instance.html#ad2e3cf28a86c237f76e44c8b4490658a&quot;,&quot;title&quot;:&quot;Maya Python API 2.0 Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderInstance.bind()</a></span> を呼び出してシェーダ インスタンスを描画コンテキストにバインドし、次に <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getLastError()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a32aa7a2b395ae162d8fc66abf5f5a14a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getLastError()</a></span> または <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getLastErrorSource()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a45e7598b79e4e7202aa4082baec16231&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getLastErrorSource()</a></span> を呼び出してエフェクトのコンパイル エラーをレポートします。</p>\n\
<p>または、シェーダに次のプラグマを設定すると、作成時にエラーが発生します。</p>\n\
<div class=\"codeBlock\"><pre class=\"prettyprint\">#pragma FullCompileOnLoad:true; \n\
</pre></div><p>次に、<span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getLastError()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a32aa7a2b395ae162d8fc66abf5f5a14a&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getLastError()</a></span> または <span class=\'code\'><a href=\"javascript:void(0)\" data-symbol=\"MShaderManager::getLastErrorSource()\" class=\"a_multireflink\" data-reflinkdata=\"[{&quot;path&quot;:&quot;cpp_ref/class_m_h_w_render_1_1_m_shader_manager.html#a45e7598b79e4e7202aa4082baec16231&quot;,&quot;title&quot;:&quot;C++ API Reference&quot;,&quot;relpathtoroot&quot;:&quot;../../&quot;}]\">MShaderManager::getLastErrorSource()</a></span> を呼び出してエフェクトのコンパイル エラーをレポートする必要があります。</p>\n\
      <div class=\"footer-block\"><a href=\"../html/ac.cmtdialog.htm\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div></div>\n\
   </div></body>\n\
</html>\n\
";